Index: trunk/src/user32/windowclass.cpp
===================================================================
--- trunk/src/user32/windowclass.cpp	(revision 6609)
+++ trunk/src/user32/windowclass.cpp	(revision 6611)
@@ -1,3 +1,3 @@
-/* $Id: windowclass.cpp,v 1.22 2001-07-13 14:31:39 sandervl Exp $ */
+/* $Id: windowclass.cpp,v 1.23 2001-08-31 13:37:39 phaller Exp $ */
 /*
  * Win32 Window Class Code for OS/2
@@ -25,4 +25,12 @@
 #include "dbglocal.h"
 
+
+#include <odin.h>
+#include <odinwrap.h>
+#include <os2sel.h>
+
+ODINDEBUGCHANNEL(USER32-CLASS)
+
+
 //******************************************************************************
 //******************************************************************************
@@ -42,5 +50,7 @@
 //Note: RegisterClassA does NOT change the last error if successful! (verified in NT 4, SP6)
 //******************************************************************************
-ATOM WIN32API RegisterClassA(CONST WNDCLASSA *lpWndClass)
+
+ODINFUNCTION1(ATOM,              RegisterClassA,
+              CONST WNDCLASSA *, lpWndClass)
 {
  WNDCLASSEXA wc;
@@ -85,5 +95,6 @@
 //Note: RegisterClassA does NOT change the last error if successful! (verified in NT 4, SP6)
 //******************************************************************************
-ATOM WIN32API RegisterClassExA(CONST WNDCLASSEXA *lpWndClass)
+ODINFUNCTION1(ATOM,                RegisterClassExA,
+              CONST WNDCLASSEXA *, lpWndClass)
 {
  Win32WndClass *wclass;
@@ -114,5 +125,6 @@
 //Note: RegisterClassA does NOT change the last error if successful! (verified in NT 4, SP6)
 //******************************************************************************
-WORD WIN32API RegisterClassW(CONST WNDCLASSW *lpwc)
+ODINFUNCTION1(ATOM,              RegisterClassW,
+              CONST WNDCLASSW *, lpwc)
 {
  ATOM rc;
@@ -157,5 +169,6 @@
 //Note: RegisterClassA does NOT change the last error if successful! (verified in NT 4, SP6)
 //******************************************************************************
-ATOM WIN32API RegisterClassExW(CONST WNDCLASSEXW *lpwc)
+ODINFUNCTION1(ATOM,                RegisterClassExW,
+              CONST WNDCLASSEXW *, lpwc)
 {
  ATOM rc;
@@ -190,5 +203,7 @@
 //******************************************************************************
 //******************************************************************************
-BOOL WIN32API UnregisterClassA(LPCSTR lpszClassName, HINSTANCE hinst)
+ODINFUNCTION2(BOOL,      UnregisterClassA,
+              LPCSTR,    lpszClassName,
+              HINSTANCE, hinst)
 {
  BOOL ret;
@@ -199,5 +214,7 @@
 //******************************************************************************
 //******************************************************************************
-BOOL WIN32API UnregisterClassW(LPCWSTR lpszClassName, HINSTANCE hinst)
+ODINFUNCTION2(BOOL,      UnregisterClassW,
+              LPCWSTR,   lpszClassName,
+              HINSTANCE, hinst)
 {
  char *astring = NULL;
@@ -218,5 +235,8 @@
 //******************************************************************************
 //******************************************************************************
-BOOL WIN32API GetClassInfoA(HINSTANCE hInstance, LPCSTR lpszClass, WNDCLASSA *lpwc)
+ODINFUNCTION3(BOOL,        GetClassInfoA,
+              HINSTANCE,   hInstance,
+              LPCSTR,      lpszClass,
+              WNDCLASSA *, lpwc)
 {
  WNDCLASSEXA    wc;
@@ -242,5 +262,8 @@
 //******************************************************************************
 //******************************************************************************
-BOOL WIN32API GetClassInfoW(HINSTANCE  hinst, LPCWSTR lpszClass, WNDCLASSW *lpwc)
+ODINFUNCTION3(BOOL,        GetClassInfoW,
+              HINSTANCE,   hinst,
+              LPCWSTR,     lpszClass,
+              WNDCLASSW *, lpwc)
 {
  WNDCLASSEXW    wc;
@@ -285,7 +308,8 @@
  * Remark    : PH: does not obtain handle of the small icon
  *****************************************************************************/
-BOOL WIN32API GetClassInfoExA(HINSTANCE     hInstance,
-                              LPCTSTR       lpszClass,
-                              LPWNDCLASSEXA lpwcx)
+ODINFUNCTION3(BOOL,          GetClassInfoExA,
+              HINSTANCE,     hInstance,
+              LPCTSTR,       lpszClass,
+              LPWNDCLASSEXA, lpwcx)
 {
  BOOL           rc;
@@ -310,4 +334,6 @@
   return(FALSE);
 }
+
+
 /*****************************************************************************
  * Name      : BOOL WIN32API GetClassInfoExW
@@ -326,7 +352,9 @@
  *
  *****************************************************************************/
-BOOL WIN32API GetClassInfoExW(HINSTANCE     hInstance,
-                                 LPCWSTR       lpszClass,
-                                 LPWNDCLASSEXW lpwcx)
+
+ODINFUNCTION3(BOOL,          GetClassInfoExW,
+              HINSTANCE,     hInstance,
+              LPCWSTR,       lpszClass,
+              LPWNDCLASSEXW, lpwcx)
 {
  BOOL           rc;
@@ -362,5 +390,8 @@
 //******************************************************************************
 //******************************************************************************
-int WIN32API GetClassNameA(HWND hwnd, LPSTR lpszClassName, int cchClassName)
+ODINFUNCTION3(int,   GetClassNameA,
+              HWND,  hwnd,
+              LPSTR, lpszClassName,
+              int,   cchClassName)
 {
  Win32BaseWindow *wnd;
@@ -380,5 +411,8 @@
 //******************************************************************************
 //******************************************************************************
-int WIN32API GetClassNameW(HWND hwnd, LPWSTR lpszClassName, int cchClassName)
+ODINFUNCTION3(int,    GetClassNameW,
+              HWND,   hwnd,
+              LPWSTR, lpszClassName,
+              int,    cchClassName)
 {
  Win32BaseWindow *wnd;
@@ -397,5 +431,8 @@
 //******************************************************************************
 //******************************************************************************
-LONG WIN32API SetClassLongA(HWND hwnd, int nIndex, LONG lNewVal)
+ODINFUNCTION3(LONG, SetClassLongA,
+			  HWND, hwnd, 
+			  int,  nIndex, 
+			  LONG, lNewVal)
 {
  Win32BaseWindow *wnd;
@@ -413,5 +450,8 @@
 //******************************************************************************
 //******************************************************************************
-LONG WIN32API SetClassLongW(HWND hwnd, int nIndex, LONG lNewVal)
+ODINFUNCTION3(LONG,   SetClassLongW,
+              HWND,   hwnd,
+              int,    nIndex,
+              LONG,   lNewVal)
 {
  Win32BaseWindow *wnd;
@@ -429,5 +469,8 @@
 //******************************************************************************
 //******************************************************************************
-WORD WIN32API SetClassWord(HWND hwnd, int nIndex, WORD  wNewVal)
+ODINFUNCTION3(WORD,  SetClassWord,
+              HWND,  hwnd,
+              int,   nIndex,
+              WORD,  wNewVal)
 {
  Win32BaseWindow *wnd;
@@ -446,5 +489,7 @@
 //******************************************************************************
 //******************************************************************************
-WORD WIN32API GetClassWord(HWND hwnd, int nIndex)
+ODINFUNCTION2(WORD, GetClassWord,
+              HWND, hwnd,
+              int,  nIndex)
 {
  Win32BaseWindow *wnd;
@@ -463,5 +508,7 @@
 //******************************************************************************
 //******************************************************************************
-LONG WIN32API GetClassLongA(HWND hwnd, int nIndex)
+ODINFUNCTION2(LONG, GetClassLongA,
+              HWND, hwnd,
+              int,  nIndex)
 {
  Win32BaseWindow *wnd;
@@ -480,5 +527,7 @@
 //******************************************************************************
 //******************************************************************************
-LONG WIN32API GetClassLongW(HWND hwnd, int nIndex)
+ODINFUNCTION2(LONG, GetClassLongW,
+              HWND, hwnd,
+              int,  nIndex)
 {
  Win32BaseWindow *wnd;