Index: trunk/src/wnetap32/makefile
===================================================================
--- trunk/src/wnetap32/makefile	(revision 6674)
+++ trunk/src/wnetap32/makefile	(revision 6676)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.18 2001-09-06 22:23:39 phaller Exp $
+# $Id: makefile,v 1.19 2001-09-07 08:20:58 phaller Exp $
 
 #
@@ -22,4 +22,7 @@
 $(OBJDIR)\server.obj \
 $(OBJDIR)\user.obj \
+$(OBJDIR)\use.obj \
+$(OBJDIR)\service.obj \
+$(OBJDIR)\share.obj \
 $(OBJDIR)\wksta.obj \
 $(OBJDIR)\repl.obj \
Index: trunk/src/wnetap32/service.cpp
===================================================================
--- trunk/src/wnetap32/service.cpp	(revision 6676)
+++ trunk/src/wnetap32/service.cpp	(revision 6676)
@@ -0,0 +1,179 @@
+/* $Id: service.cpp,v 1.1 2001-09-07 08:20:58 phaller Exp $ */
+
+/*
+ *
+ * Project Odin Software License can be found in LICENSE.TXT
+ *
+ */
+/*
+ * NETAPI32 service manager APIs
+ *
+ * Copyright 1998 Patrick Haller
+ *
+ * Note: functions that return structures/buffers seem to append strings
+ * at the end of the buffer. Currently, we just allocate the strings
+ * "normally". Therefore a caller that just does a NetApiBufferFree() on the
+ * returned buffer will leak all allocated strings.
+ *
+ */
+
+
+/****************************************************************************
+ * Includes                                                                 *
+ ****************************************************************************/
+
+#include <odin.h>
+#include <odinwrap.h>
+#include <os2win.h>
+#include <misc.h>
+#include <unicode.h>
+#include <heapstring.h>
+#include <string.h>
+#include <winconst.h>
+
+#include "oslibnet.h"
+#include "lanman.h"
+
+ODINDEBUGCHANNEL(WNETAP32-SERVICE)
+
+
+/****************************************************************************
+ * Module Global Variables                                                  *
+ ****************************************************************************/
+
+#define NCBNAMSZ        16
+#define MAX_LANA       254
+
+
+/*****************************************************************************
+ * Name      : NET_API_STATUS NetServiceControl
+ * Purpose   : controls operations of network services
+ * Parameters: LPWSTR  lpServerName
+ *             LPWSTR  lpService
+ *             DWORD   dwOpcode
+ *             DWORD   dwArgument
+ *             LPBYTE* bufptr
+ * Variables :
+ * Result    :
+ * Remark    :
+ * Status    : UNTESTED STUB
+ *
+ * Author    : Patrick Haller [Thu, 1999/08/18 00:15]
+ *****************************************************************************/
+
+ODINFUNCTION5(NET_API_STATUS, OS2NetServiceControl,
+              LPWSTR, lpServerName,
+              LPWSTR, lpService,
+              DWORD, dwOpcode,
+              DWORD, dwArgument,
+              LPBYTE*, bufptr)
+{
+  dprintf(("NETAPI32: NetServiceControl(%08xh,%08xh,%08xh,%08xh,%08xh) not implemented\n",
+           lpServerName,
+           lpService,
+           dwOpcode,
+           dwArgument,
+           bufptr));
+
+  return (NERR_BASE);
+}
+
+
+/*****************************************************************************
+ * Name      : NET_API_STATUS NetServiceEnum
+ * Purpose   : retrieves information about all started services
+ * Parameters: LPWSTR  lpServerName
+ *             DWORD   dwLevel
+ *             LPBYTE* bufptr
+ *             DWORD   dwPrefMaxLen
+ *             LPDWORD lpdEntriesRead
+ *             LPDWORD lpdTotalEntries
+ *             LPDWORD lpdResumeHandle
+ * Variables :
+ * Result    :
+ * Remark    :
+ * Status    : UNTESTED STUB
+ *
+ * Author    : Patrick Haller [Thu, 1999/08/18 00:15]
+ *****************************************************************************/
+
+ODINFUNCTION7(NET_API_STATUS, OS2NetServiceEnum,
+              LPWSTR, lpServerName,
+              DWORD, dwLevel,
+              LPBYTE*, bufptr,
+              DWORD, dwPrefMaxLen,
+              LPDWORD, lpdEntriesRead,
+              LPDWORD, lpdTotalEntries,
+              LPDWORD, lpdResumeHandle)
+{
+  dprintf(("NETAPI32: NetServiceEnum(%08xh,%08xh,%08xh,%08xh,%08xh,%08xh,%08xh) not implemented\n",
+           lpServerName,
+           dwLevel,
+           bufptr,
+           dwPrefMaxLen,
+           lpdEntriesRead,
+           lpdTotalEntries,
+           lpdResumeHandle));
+
+  return (NERR_BASE);
+}
+
+
+/*****************************************************************************
+ * Name      : NET_API_STATUS NetServiceGetInfo
+ * Purpose   : retrieves information about a particular started service
+ * Parameters: LPWSTR  lpServerName
+ *             LPWSTR  lpService
+ *             DWORD   dwLevel
+ *             LPBYTE* bufptr
+ * Variables :
+ * Result    :
+ * Remark    :
+ * Status    : UNTESTED STUB
+ *
+ * Author    : Patrick Haller [Thu, 1999/08/18 00:15]
+ *****************************************************************************/
+
+ODINFUNCTION4(NET_API_STATUS, OS2NetServiceGetInfo,
+              LPWSTR, lpServerName,
+              LPWSTR, lpService,
+              DWORD, dwLevel,
+              LPBYTE*, bufptr)
+{
+  dprintf(("NETAPI32: NetServiceGetInfo(%08xh,%08xh,%08xh,%08xh) not implemented\n",
+           lpServerName,
+           lpService,
+           dwLevel,
+           bufptr));
+
+  return (NERR_BASE);
+}
+
+
+/*****************************************************************************
+ * Name      : NET_API_STATUS NetServiceInstall
+ * Purpose   : starts a network service
+ * Parameters: LPWSTR  lpServerName
+ *             LPWSTR  lpService
+ *             DWORD   argc
+ *             LPWSTR  argv[]
+ *             LPBYTE* bufptr
+ * Variables :
+ * Result    :
+ * Remark    :
+ * Status    : UNTESTED STUB
+ *
+ * Author    : Patrick Haller [Thu, 1999/08/18 00:15]
+ *****************************************************************************/
+
+ODINFUNCTION5(NET_API_STATUS, OS2NetServiceInstall,
+              LPWSTR, lpServerName,
+              LPWSTR, lpService,
+              DWORD, argc,
+              LPWSTR*, argv,
+              LPBYTE*, bufptr)
+{
+  dprintf(("NETAPI32: NetServiceInstall not implemented\n"));
+
+  return (NERR_BASE);
+}
Index: trunk/src/wnetap32/share.cpp
===================================================================
--- trunk/src/wnetap32/share.cpp	(revision 6676)
+++ trunk/src/wnetap32/share.cpp	(revision 6676)
@@ -0,0 +1,290 @@
+/* $Id: share.cpp,v 1.1 2001-09-07 08:20:58 phaller Exp $ */
+
+/*
+ *
+ * Project Odin Software License can be found in LICENSE.TXT
+ *
+ */
+/*
+ * NETAPI32 share APIs
+ *
+ * Copyright 1998 Patrick Haller
+ *
+ * Note: functions that return structures/buffers seem to append strings
+ * at the end of the buffer. Currently, we just allocate the strings
+ * "normally". Therefore a caller that just does a NetApiBufferFree() on the
+ * returned buffer will leak all allocated strings.
+ *
+ */
+
+
+/****************************************************************************
+ * Includes                                                                 *
+ ****************************************************************************/
+
+#include <odin.h>
+#include <odinwrap.h>
+#include <os2win.h>
+#include <misc.h>
+#include <unicode.h>
+#include <heapstring.h>
+#include <string.h>
+#include <winconst.h>
+
+#include "oslibnet.h"
+#include "lanman.h"
+
+ODINDEBUGCHANNEL(WNETAP32-SHARE)
+
+
+/****************************************************************************
+ * Module Global Variables                                                  *
+ ****************************************************************************/
+
+
+/*****************************************************************************
+ * Name      : NET_API_STATUS NetShareAdd
+ * Purpose   :
+ * Parameters: LPWSTR servername
+ *             DWORD level
+ *             LPBYTE buf
+ *             LPDWORD parm_err
+ * Variables :
+ * Result    :
+ * Remark    :
+ * Status    : UNTESTED STUB
+ *
+ * Stub Generated through PE2LX Stubwizard 0.02 from Markus Montkowski
+ *
+ * Author    : Markus Montkowski [09.07.98 22:01:48]
+ *****************************************************************************/
+ODINFUNCTION4(NET_API_STATUS, OS2NetShareAdd,
+              LPWSTR, servername,
+              DWORD, level,
+              LPBYTE, buf,
+              LPDWORD, parm_err)
+
+{
+
+  dprintf(("NETAPI32: NetShareAdd(%s, %d, %08x, %08x) not implemented\n"
+           ,servername, level, buf, parm_err
+         ));
+
+  return (NERR_BASE);
+}
+
+
+/*****************************************************************************
+ * Name      : NET_API_STATUS NetShareCheck
+ * Purpose   :
+ * Parameters: LPWSTR servername
+ *             LPWSTR device
+ *             LPDWORD type
+ * Variables :
+ * Result    :
+ * Remark    :
+ * Status    : UNTESTED STUB
+ *
+ * Stub Generated through PE2LX Stubwizard 0.02 from Markus Montkowski
+ *
+ * Author    : Markus Montkowski [09.07.98 22:02:16]
+ *****************************************************************************/
+ODINFUNCTION3(NET_API_STATUS, OS2NetShareCheck,
+              LPWSTR, servername,
+              LPWSTR, device,
+              LPDWORD, type)
+
+{
+
+  dprintf(("NETAPI32: NetShareCheck(%s, %s, %08x) not implemented\n"
+           ,servername, device, type
+         ));
+
+  return (NERR_BASE);
+}
+
+
+/*****************************************************************************
+ * Name      : NET_API_STATUS NetShareDel
+ * Purpose   :
+ * Parameters: LPWSTR servername
+ *             LPWSTR netname
+ *             DWORD reserved
+ * Variables :
+ * Result    :
+ * Remark    :
+ * Status    : UNTESTED STUB
+ *
+ * Stub Generated through PE2LX Stubwizard 0.02 from Markus Montkowski
+ *
+ * Author    : Markus Montkowski [09.07.98 22:03:01]
+ *****************************************************************************/
+ODINFUNCTION3(NET_API_STATUS, OS2NetShareDel,
+              LPWSTR, servername,
+              LPWSTR, netname,
+              DWORD, reserved)
+
+{
+
+  dprintf(("NETAPI32: NetShareDel(%s, %s, %d) not implemented\n"
+           ,servername, netname, reserved
+         ));
+
+  return (NERR_BASE);
+}
+
+
+/*****************************************************************************
+ * Name      : NET_API_STATUS NetShareGetInfo
+ * Purpose   :
+ * Parameters: LPWSTR servername
+ *             LPWSTR netname
+ *             DWORD level
+ *             LPBYTE *bufptr
+ * Variables :
+ * Result    :
+ * Remark    :
+ * Status    : UNTESTED STUB
+ *
+ * Stub Generated through PE2LX Stubwizard 0.02 from Markus Montkowski
+ *
+ * Author    : Markus Montkowski [09.07.98 22:03:39]
+ *****************************************************************************/
+ODINFUNCTION4(NET_API_STATUS, OS2NetShareGetInfo,
+              LPWSTR, servername,
+              LPWSTR, netname,
+              DWORD, level,
+              LPBYTE *, bufptr)
+
+{
+
+  dprintf(("NETAPI32: NetShareGetInfo(%s, %s, %d, %08x) not implemented\n"
+           ,servername, netname, level, *bufptr
+         ));
+
+  return (NERR_BASE);
+}
+/*****************************************************************************
+ * Name      : NET_API_STATUS NetShareSetInfo
+ * Purpose   :
+ * Parameters: LPWSTR servername
+ *             LPWSTR netname
+ *             DWORD level
+ *             LPBYTE buf
+ *             LPDWORD parm_err
+ * Variables :
+ * Result    :
+ * Remark    :
+ * Status    : UNTESTED STUB
+ *
+ * Stub Generated through PE2LX Stubwizard 0.02 from Markus Montkowski
+ *
+ * Author    : Markus Montkowski [09.07.98 22:04:00]
+ *****************************************************************************/
+ODINFUNCTION5(NET_API_STATUS, OS2NetShareSetInfo,
+              LPWSTR, servername,
+              LPWSTR, netname,
+              DWORD, level,
+              LPBYTE, buf,
+              LPDWORD, parm_err)
+
+{
+
+  dprintf(("NETAPI32: NetShareSetInfo(%s, %s, %d, %08x, %08x) not implemented\n"
+           ,servername, netname, level, buf, parm_err
+         ));
+
+  return (NERR_BASE);
+}
+
+
+/*****************************************************************************
+ * Name      : NET_API_STATUS NetShareDel
+ * Purpose   :
+ * Parameters: LPWSTR servername
+ *             LPWSTR netname
+ *             DWORD reserved
+ * Variables :
+ * Result    :
+ * Remark    :
+ * Status    : UNTESTED STUB
+ *
+ * Stub Generated through PE2LX Stubwizard 0.02 from Markus Montkowski
+ *
+ * Author    : Markus Montkowski [09.07.98 22:03:01]
+ *****************************************************************************/
+
+ODINFUNCTION3(NET_API_STATUS,OS2NetShareDelSticky,LPWSTR, servername,
+                                                  LPWSTR, netname,
+                                                  DWORD,  reserved)
+{
+
+  dprintf(("NETAPI32: NetShareDelSticky not implemented\n"));
+
+  return (NERR_BASE);
+}
+
+
+/*****************************************************************************
+ * Name      : NET_API_STATUS NetShareEnum
+ * Purpose   : retrieves information about all shared devices
+ * Parameters: LPWSTR  lpServerName
+ *             DWORD   dwLevel
+ *             LPBYTE* bufptr
+ *             DWORD   dwPrefMaxLen
+ *             LPDWORD lpdEntriesRead
+ *             LPDWORD lpdTotalEntries
+ *             LPDWORD lpdResumeHandle
+ * Variables :
+ * Result    :
+ * Remark    :
+ * Status    : UNTESTED STUB
+ *
+ * Author    : Patrick Haller [Thu, 1999/08/18 00:15]
+ *****************************************************************************/
+
+ODINFUNCTION7(NET_API_STATUS,OS2NetShareEnum,LPWSTR,  lpServerName,
+                                             DWORD,   dwLevel,
+                                             LPBYTE*, bufptr,
+                                             DWORD,   dwPrefMaxLen,
+                                             LPDWORD, lpdEntriesRead,
+                                             LPDWORD, lpdTotalEntries,
+                                             LPDWORD, lpdResumeHandle)
+{
+  dprintf(("NETAPI32: NetShareEnum not implemented\n"));
+
+  return (NERR_BASE);
+}
+
+
+
+/*****************************************************************************
+ * Name      : NET_API_STATUS NetShareEnumSticky
+ * Purpose   : retrieves information about all sticky shared devices
+ * Parameters: LPWSTR  lpServerName
+ *             DWORD   dwLevel
+ *             LPBYTE* bufptr
+ *             DWORD   dwPrefMaxLen
+ *             LPDWORD lpdEntriesRead
+ *             LPDWORD lpdTotalEntries
+ *             LPDWORD lpdResumeHandle
+ * Variables :
+ * Result    :
+ * Remark    :
+ * Status    : UNTESTED STUB
+ *
+ * Author    : Patrick Haller [Thu, 1999/08/18 00:15]
+ *****************************************************************************/
+
+ODINFUNCTION7(NET_API_STATUS,OS2NetShareEnumSticky,LPWSTR,  lpServerName,
+                                                   DWORD,   dwLevel,
+                                                   LPBYTE*, bufptr,
+                                                   DWORD,   dwPrefMaxLen,
+                                                   LPDWORD, lpdEntriesRead,
+                                                   LPDWORD, lpdTotalEntries,
+                                                   LPDWORD, lpdResumeHandle)
+{
+  dprintf(("NETAPI32: NetShareEnumSticky not implemented\n"));
+
+  return (NERR_BASE);
+}
Index: trunk/src/wnetap32/use.cpp
===================================================================
--- trunk/src/wnetap32/use.cpp	(revision 6676)
+++ trunk/src/wnetap32/use.cpp	(revision 6676)
@@ -0,0 +1,163 @@
+/* $Id: use.cpp,v 1.1 2001-09-07 08:20:59 phaller Exp $ */
+
+/*
+ *
+ * Project Odin Software License can be found in LICENSE.TXT
+ *
+ */
+/*
+ * NETAPI32 "use" APIs
+ *
+ * Copyright 1998 Patrick Haller
+ *
+ * Note: functions that return structures/buffers seem to append strings
+ * at the end of the buffer. Currently, we just allocate the strings
+ * "normally". Therefore a caller that just does a NetApiBufferFree() on the
+ * returned buffer will leak all allocated strings.
+ *
+ */
+
+
+/****************************************************************************
+ * Includes                                                                 *
+ ****************************************************************************/
+
+#include <odin.h>
+#include <odinwrap.h>
+#include <os2win.h>
+#include <misc.h>
+#include <unicode.h>
+#include <heapstring.h>
+#include <string.h>
+#include <winconst.h>
+
+#include "oslibnet.h"
+#include "lanman.h"
+
+ODINDEBUGCHANNEL(WNETAP32-USE)
+
+
+/****************************************************************************
+ * Module Global Variables                                                  *
+ ****************************************************************************/
+
+
+/*****************************************************************************
+ * Name      : NET_API_STATUS NetUseAdd
+ * Purpose   : add remote device association
+ * Parameters: LPWSTR  lpUncServerName
+ *             DWORD   dwLevel
+ *             LPBYTE  lpBuf
+ *             LPDWORD lpParmError
+ * Variables :
+ * Result    :
+ * Remark    :
+ * Status    : UNTESTED STUB
+ *
+ * Author    : Patrick Haller [Thu, 1999/08/18 00:15]
+ *****************************************************************************/
+
+ODINFUNCTION4(NET_API_STATUS, OS2NetUseAdd,
+              LPWSTR, lpUncServerName,
+              DWORD, dwLevel,
+              LPBYTE, lpBuf,
+              LPDWORD, lpParmError)
+{
+  dprintf(("NETAPI32: NetUseAdd(%08xh,%08xh,%08xh,%08xh) not implemented\n",
+           lpUncServerName,
+           dwLevel,
+           lpBuf,
+           lpParmError));
+
+  return (NERR_BASE);
+}
+
+
+/*****************************************************************************
+ * Name      : NET_API_STATUS NetUseDel
+ * Purpose   : remove remote device association
+ * Parameters: LPWSTR  lpUncServerName
+ *             LPWSTR  lpUseName
+ *             DWORD   dwForceCond
+ * Variables :
+ * Result    :
+ * Remark    :
+ * Status    : UNTESTED STUB
+ *
+ * Author    : Patrick Haller [Thu, 1999/08/18 00:15]
+ *****************************************************************************/
+
+ODINFUNCTION3(NET_API_STATUS, OS2NetUseDel,
+              LPWSTR, lpUncServerName,
+              LPWSTR, lpUseName,
+              DWORD, dwForceCond)
+{
+  dprintf(("NETAPI32: NetUseDel(%08xh,%08xh,%08xh) not implemented\n",
+           lpUncServerName,
+           lpUseName,
+           dwForceCond));
+
+  return (NERR_BASE);
+}
+
+
+/*****************************************************************************
+ * Name      : NET_API_STATUS NetUseEnum
+ * Purpose   : retrieves information about all used devices
+ * Parameters: LPWSTR  lpServerName
+ *             DWORD   dwLevel
+ *             LPBYTE* bufptr
+ *             DWORD   dwPrefMaxLen
+ *             LPDWORD lpdEntriesRead
+ *             LPDWORD lpdTotalEntries
+ *             LPDWORD lpdResumeHandle
+ * Variables :
+ * Result    :
+ * Remark    :
+ * Status    : UNTESTED STUB
+ *
+ * Author    : Patrick Haller [Thu, 1999/08/18 00:15]
+ *****************************************************************************/
+
+ODINFUNCTION7(NET_API_STATUS,OS2NetUseEnum,LPWSTR,  lpServerName,
+                                           DWORD,   dwLevel,
+                                           LPBYTE*, bufptr,
+                                           DWORD,   dwPrefMaxLen,
+                                           LPDWORD, lpdEntriesRead,
+                                           LPDWORD, lpdTotalEntries,
+                                           LPDWORD, lpdResumeHandle)
+{
+  dprintf(("NETAPI32: NetUseEnum not implemented\n"));
+
+  return (NERR_BASE);
+}
+
+
+/*****************************************************************************
+ * Name      : NET_API_STATUS NetUseGetInfo
+ * Purpose   :
+ * Parameters: LPWSTR lpServerName
+ *             LPWSTR lpUseName
+ *             DWORD  dwlevel
+ *             LPBYTE *bufptr
+ * Variables :
+ * Result    :
+ * Remark    :
+ * Status    : UNTESTED STUB
+ *
+ * Stub Generated through PE2LX Stubwizard 0.02 from Markus Montkowski
+ *
+ * Author    : Markus Montkowski [09.07.98 21:28:38]
+ *****************************************************************************/
+
+ODINFUNCTION4(NET_API_STATUS,OS2NetUseGetInfo,LPWSTR,  lpServerName,
+                                              LPWSTR,  lpUseName,
+                                              DWORD,   dwLevel,
+                                              LPBYTE*, bufptr)
+
+{
+
+  dprintf(("NETAPI32: NetUseGetInfo not implemented\n"));
+
+  return (NERR_BASE);
+}
Index: trunk/src/wnetap32/wnetap32.cpp
===================================================================
--- trunk/src/wnetap32/wnetap32.cpp	(revision 6674)
+++ trunk/src/wnetap32/wnetap32.cpp	(revision 6676)
@@ -1,3 +1,3 @@
-/* $Id: wnetap32.cpp,v 1.15 2001-09-06 22:23:41 phaller Exp $ */
+/* $Id: wnetap32.cpp,v 1.16 2001-09-07 08:20:59 phaller Exp $ */
 
 /*
@@ -737,158 +737,5 @@
   return (NERR_BASE);
 }
-/*****************************************************************************
- * Name      : NET_API_STATUS NetShareAdd
- * Purpose   :
- * Parameters: LPWSTR servername
- *             DWORD level
- *             LPBYTE buf
- *             LPDWORD parm_err
- * Variables :
- * Result    :
- * Remark    :
- * Status    : UNTESTED STUB
- *
- * Stub Generated through PE2LX Stubwizard 0.02 from Markus Montkowski
- *
- * Author    : Markus Montkowski [09.07.98 22:01:48]
- *****************************************************************************/
-ODINFUNCTION4(NET_API_STATUS, OS2NetShareAdd,
-              LPWSTR, servername,
-              DWORD, level,
-              LPBYTE, buf,
-              LPDWORD, parm_err)
-
-{
-
-  dprintf(("NETAPI32: NetShareAdd(%s, %d, %08x, %08x) not implemented\n"
-           ,servername, level, buf, parm_err
-         ));
-
-  return (NERR_BASE);
-}
-
-
-/*****************************************************************************
- * Name      : NET_API_STATUS NetShareCheck
- * Purpose   :
- * Parameters: LPWSTR servername
- *             LPWSTR device
- *             LPDWORD type
- * Variables :
- * Result    :
- * Remark    :
- * Status    : UNTESTED STUB
- *
- * Stub Generated through PE2LX Stubwizard 0.02 from Markus Montkowski
- *
- * Author    : Markus Montkowski [09.07.98 22:02:16]
- *****************************************************************************/
-ODINFUNCTION3(NET_API_STATUS, OS2NetShareCheck,
-              LPWSTR, servername,
-              LPWSTR, device,
-              LPDWORD, type)
-
-{
-
-  dprintf(("NETAPI32: NetShareCheck(%s, %s, %08x) not implemented\n"
-           ,servername, device, type
-         ));
-
-  return (NERR_BASE);
-}
-
-
-/*****************************************************************************
- * Name      : NET_API_STATUS NetShareDel
- * Purpose   :
- * Parameters: LPWSTR servername
- *             LPWSTR netname
- *             DWORD reserved
- * Variables :
- * Result    :
- * Remark    :
- * Status    : UNTESTED STUB
- *
- * Stub Generated through PE2LX Stubwizard 0.02 from Markus Montkowski
- *
- * Author    : Markus Montkowski [09.07.98 22:03:01]
- *****************************************************************************/
-ODINFUNCTION3(NET_API_STATUS, OS2NetShareDel,
-              LPWSTR, servername,
-              LPWSTR, netname,
-              DWORD, reserved)
-
-{
-
-  dprintf(("NETAPI32: NetShareDel(%s, %s, %d) not implemented\n"
-           ,servername, netname, reserved
-         ));
-
-  return (NERR_BASE);
-}
-
-
-/*****************************************************************************
- * Name      : NET_API_STATUS NetShareGetInfo
- * Purpose   :
- * Parameters: LPWSTR servername
- *             LPWSTR netname
- *             DWORD level
- *             LPBYTE *bufptr
- * Variables :
- * Result    :
- * Remark    :
- * Status    : UNTESTED STUB
- *
- * Stub Generated through PE2LX Stubwizard 0.02 from Markus Montkowski
- *
- * Author    : Markus Montkowski [09.07.98 22:03:39]
- *****************************************************************************/
-ODINFUNCTION4(NET_API_STATUS, OS2NetShareGetInfo,
-              LPWSTR, servername,
-              LPWSTR, netname,
-              DWORD, level,
-              LPBYTE *, bufptr)
-
-{
-
-  dprintf(("NETAPI32: NetShareGetInfo(%s, %s, %d, %08x) not implemented\n"
-           ,servername, netname, level, *bufptr
-         ));
-
-  return (NERR_BASE);
-}
-/*****************************************************************************
- * Name      : NET_API_STATUS NetShareSetInfo
- * Purpose   :
- * Parameters: LPWSTR servername
- *             LPWSTR netname
- *             DWORD level
- *             LPBYTE buf
- *             LPDWORD parm_err
- * Variables :
- * Result    :
- * Remark    :
- * Status    : UNTESTED STUB
- *
- * Stub Generated through PE2LX Stubwizard 0.02 from Markus Montkowski
- *
- * Author    : Markus Montkowski [09.07.98 22:04:00]
- *****************************************************************************/
-ODINFUNCTION5(NET_API_STATUS, OS2NetShareSetInfo,
-              LPWSTR, servername,
-              LPWSTR, netname,
-              DWORD, level,
-              LPBYTE, buf,
-              LPDWORD, parm_err)
-
-{
-
-  dprintf(("NETAPI32: NetShareSetInfo(%s, %s, %d, %08x, %08x) not implemented\n"
-           ,servername, netname, level, buf, parm_err
-         ));
-
-  return (NERR_BASE);
-}
+
 
 /*****************************************************************************
@@ -1268,198 +1115,4 @@
            x2,
            x3));
-
-  return (NERR_BASE);
-}
-
-
-/*****************************************************************************
- * Name      : NET_API_STATUS NetUseAdd
- * Purpose   : add remote device association
- * Parameters: LPWSTR  lpUncServerName
- *             DWORD   dwLevel
- *             LPBYTE  lpBuf
- *             LPDWORD lpParmError
- * Variables :
- * Result    :
- * Remark    :
- * Status    : UNTESTED STUB
- *
- * Author    : Patrick Haller [Thu, 1999/08/18 00:15]
- *****************************************************************************/
-
-ODINFUNCTION4(NET_API_STATUS, OS2NetUseAdd,
-              LPWSTR, lpUncServerName,
-              DWORD, dwLevel,
-              LPBYTE, lpBuf,
-              LPDWORD, lpParmError)
-{
-  dprintf(("NETAPI32: NetUseAdd(%08xh,%08xh,%08xh,%08xh) not implemented\n",
-           lpUncServerName,
-           dwLevel,
-           lpBuf,
-           lpParmError));
-
-  return (NERR_BASE);
-}
-
-
-/*****************************************************************************
- * Name      : NET_API_STATUS NetUseDel
- * Purpose   : remove remote device association
- * Parameters: LPWSTR  lpUncServerName
- *             LPWSTR  lpUseName
- *             DWORD   dwForceCond
- * Variables :
- * Result    :
- * Remark    :
- * Status    : UNTESTED STUB
- *
- * Author    : Patrick Haller [Thu, 1999/08/18 00:15]
- *****************************************************************************/
-
-ODINFUNCTION3(NET_API_STATUS, OS2NetUseDel,
-              LPWSTR, lpUncServerName,
-              LPWSTR, lpUseName,
-              DWORD, dwForceCond)
-{
-  dprintf(("NETAPI32: NetUseDel(%08xh,%08xh,%08xh) not implemented\n",
-           lpUncServerName,
-           lpUseName,
-           dwForceCond));
-
-  return (NERR_BASE);
-}
-
-
-
-/*****************************************************************************
- * Name      : NET_API_STATUS NetServiceControl
- * Purpose   : controls operations of network services
- * Parameters: LPWSTR  lpServerName
- *             LPWSTR  lpService
- *             DWORD   dwOpcode
- *             DWORD   dwArgument
- *             LPBYTE* bufptr
- * Variables :
- * Result    :
- * Remark    :
- * Status    : UNTESTED STUB
- *
- * Author    : Patrick Haller [Thu, 1999/08/18 00:15]
- *****************************************************************************/
-
-ODINFUNCTION5(NET_API_STATUS, OS2NetServiceControl,
-              LPWSTR, lpServerName,
-              LPWSTR, lpService,
-              DWORD, dwOpcode,
-              DWORD, dwArgument,
-              LPBYTE*, bufptr)
-{
-  dprintf(("NETAPI32: NetServiceControl(%08xh,%08xh,%08xh,%08xh,%08xh) not implemented\n",
-           lpServerName,
-           lpService,
-           dwOpcode,
-           dwArgument,
-           bufptr));
-
-  return (NERR_BASE);
-}
-
-
-/*****************************************************************************
- * Name      : NET_API_STATUS NetServiceEnum
- * Purpose   : retrieves information about all started services
- * Parameters: LPWSTR  lpServerName
- *             DWORD   dwLevel
- *             LPBYTE* bufptr
- *             DWORD   dwPrefMaxLen
- *             LPDWORD lpdEntriesRead
- *             LPDWORD lpdTotalEntries
- *             LPDWORD lpdResumeHandle
- * Variables :
- * Result    :
- * Remark    :
- * Status    : UNTESTED STUB
- *
- * Author    : Patrick Haller [Thu, 1999/08/18 00:15]
- *****************************************************************************/
-
-ODINFUNCTION7(NET_API_STATUS, OS2NetServiceEnum,
-              LPWSTR, lpServerName,
-              DWORD, dwLevel,
-              LPBYTE*, bufptr,
-              DWORD, dwPrefMaxLen,
-              LPDWORD, lpdEntriesRead,
-              LPDWORD, lpdTotalEntries,
-              LPDWORD, lpdResumeHandle)
-{
-  dprintf(("NETAPI32: NetServiceEnum(%08xh,%08xh,%08xh,%08xh,%08xh,%08xh,%08xh) not implemented\n",
-           lpServerName,
-           dwLevel,
-           bufptr,
-           dwPrefMaxLen,
-           lpdEntriesRead,
-           lpdTotalEntries,
-           lpdResumeHandle));
-
-  return (NERR_BASE);
-}
-
-
-/*****************************************************************************
- * Name      : NET_API_STATUS NetServiceGetInfo
- * Purpose   : retrieves information about a particular started service
- * Parameters: LPWSTR  lpServerName
- *             LPWSTR  lpService
- *             DWORD   dwLevel
- *             LPBYTE* bufptr
- * Variables :
- * Result    :
- * Remark    :
- * Status    : UNTESTED STUB
- *
- * Author    : Patrick Haller [Thu, 1999/08/18 00:15]
- *****************************************************************************/
-
-ODINFUNCTION4(NET_API_STATUS, OS2NetServiceGetInfo,
-              LPWSTR, lpServerName,
-              LPWSTR, lpService,
-              DWORD, dwLevel,
-              LPBYTE*, bufptr)
-{
-  dprintf(("NETAPI32: NetServiceGetInfo(%08xh,%08xh,%08xh,%08xh) not implemented\n",
-           lpServerName,
-           lpService,
-           dwLevel,
-           bufptr));
-
-  return (NERR_BASE);
-}
-
-
-/*****************************************************************************
- * Name      : NET_API_STATUS NetServiceInstall
- * Purpose   : starts a network service
- * Parameters: LPWSTR  lpServerName
- *             LPWSTR  lpService
- *             DWORD   argc
- *             LPWSTR  argv[]
- *             LPBYTE* bufptr
- * Variables :
- * Result    :
- * Remark    :
- * Status    : UNTESTED STUB
- *
- * Author    : Patrick Haller [Thu, 1999/08/18 00:15]
- *****************************************************************************/
-
-ODINFUNCTION5(NET_API_STATUS, OS2NetServiceInstall,
-              LPWSTR, lpServerName,
-              LPWSTR, lpService,
-              DWORD, argc,
-              LPWSTR*, argv,
-              LPBYTE*, bufptr)
-{
-  dprintf(("NETAPI32: NetServiceInstall not implemented\n"));
 
   return (NERR_BASE);
@@ -1706,158 +1359,4 @@
 {
   dprintf(("NETAPI32: NetFileClose not implemented\n"));
-
-  return (NERR_BASE);
-}
-
-
-/*****************************************************************************
- * Name      : NET_API_STATUS NetShareDel
- * Purpose   :
- * Parameters: LPWSTR servername
- *             LPWSTR netname
- *             DWORD reserved
- * Variables :
- * Result    :
- * Remark    :
- * Status    : UNTESTED STUB
- *
- * Stub Generated through PE2LX Stubwizard 0.02 from Markus Montkowski
- *
- * Author    : Markus Montkowski [09.07.98 22:03:01]
- *****************************************************************************/
-
-ODINFUNCTION3(NET_API_STATUS,OS2NetShareDelSticky,LPWSTR, servername,
-                                                  LPWSTR, netname,
-                                                  DWORD,  reserved)
-{
-
-  dprintf(("NETAPI32: NetShareDelSticky not implemented\n"));
-
-  return (NERR_BASE);
-}
-
-
-/*****************************************************************************
- * Name      : NET_API_STATUS NetShareEnum
- * Purpose   : retrieves information about all shared devices
- * Parameters: LPWSTR  lpServerName
- *             DWORD   dwLevel
- *             LPBYTE* bufptr
- *             DWORD   dwPrefMaxLen
- *             LPDWORD lpdEntriesRead
- *             LPDWORD lpdTotalEntries
- *             LPDWORD lpdResumeHandle
- * Variables :
- * Result    :
- * Remark    :
- * Status    : UNTESTED STUB
- *
- * Author    : Patrick Haller [Thu, 1999/08/18 00:15]
- *****************************************************************************/
-
-ODINFUNCTION7(NET_API_STATUS,OS2NetShareEnum,LPWSTR,  lpServerName,
-                                             DWORD,   dwLevel,
-                                             LPBYTE*, bufptr,
-                                             DWORD,   dwPrefMaxLen,
-                                             LPDWORD, lpdEntriesRead,
-                                             LPDWORD, lpdTotalEntries,
-                                             LPDWORD, lpdResumeHandle)
-{
-  dprintf(("NETAPI32: NetShareEnum not implemented\n"));
-
-  return (NERR_BASE);
-}
-
-
-
-/*****************************************************************************
- * Name      : NET_API_STATUS NetShareEnumSticky
- * Purpose   : retrieves information about all sticky shared devices
- * Parameters: LPWSTR  lpServerName
- *             DWORD   dwLevel
- *             LPBYTE* bufptr
- *             DWORD   dwPrefMaxLen
- *             LPDWORD lpdEntriesRead
- *             LPDWORD lpdTotalEntries
- *             LPDWORD lpdResumeHandle
- * Variables :
- * Result    :
- * Remark    :
- * Status    : UNTESTED STUB
- *
- * Author    : Patrick Haller [Thu, 1999/08/18 00:15]
- *****************************************************************************/
-
-ODINFUNCTION7(NET_API_STATUS,OS2NetShareEnumSticky,LPWSTR,  lpServerName,
-                                                   DWORD,   dwLevel,
-                                                   LPBYTE*, bufptr,
-                                                   DWORD,   dwPrefMaxLen,
-                                                   LPDWORD, lpdEntriesRead,
-                                                   LPDWORD, lpdTotalEntries,
-                                                   LPDWORD, lpdResumeHandle)
-{
-  dprintf(("NETAPI32: NetShareEnumSticky not implemented\n"));
-
-  return (NERR_BASE);
-}
-
-
-/*****************************************************************************
- * Name      : NET_API_STATUS NetUseEnum
- * Purpose   : retrieves information about all used devices
- * Parameters: LPWSTR  lpServerName
- *             DWORD   dwLevel
- *             LPBYTE* bufptr
- *             DWORD   dwPrefMaxLen
- *             LPDWORD lpdEntriesRead
- *             LPDWORD lpdTotalEntries
- *             LPDWORD lpdResumeHandle
- * Variables :
- * Result    :
- * Remark    :
- * Status    : UNTESTED STUB
- *
- * Author    : Patrick Haller [Thu, 1999/08/18 00:15]
- *****************************************************************************/
-
-ODINFUNCTION7(NET_API_STATUS,OS2NetUseEnum,LPWSTR,  lpServerName,
-                                           DWORD,   dwLevel,
-                                           LPBYTE*, bufptr,
-                                           DWORD,   dwPrefMaxLen,
-                                           LPDWORD, lpdEntriesRead,
-                                           LPDWORD, lpdTotalEntries,
-                                           LPDWORD, lpdResumeHandle)
-{
-  dprintf(("NETAPI32: NetUseEnum not implemented\n"));
-
-  return (NERR_BASE);
-}
-
-
-/*****************************************************************************
- * Name      : NET_API_STATUS NetUseGetInfo
- * Purpose   :
- * Parameters: LPWSTR lpServerName
- *             LPWSTR lpUseName
- *             DWORD  dwlevel
- *             LPBYTE *bufptr
- * Variables :
- * Result    :
- * Remark    :
- * Status    : UNTESTED STUB
- *
- * Stub Generated through PE2LX Stubwizard 0.02 from Markus Montkowski
- *
- * Author    : Markus Montkowski [09.07.98 21:28:38]
- *****************************************************************************/
-
-ODINFUNCTION4(NET_API_STATUS,OS2NetUseGetInfo,LPWSTR,  lpServerName,
-                                              LPWSTR,  lpUseName,
-                                              DWORD,   dwLevel,
-                                              LPBYTE*, bufptr)
-
-{
-
-  dprintf(("NETAPI32: NetUseGetInfo not implemented\n"));
 
   return (NERR_BASE);